import pygame
import random
from pygame.locals import *
import os,sys

from practicum import findDevices
from peri import PeriBoard

devs = findDevices()

if len(devs) == 0:
	print "*** No MCU board found."
	exit(1)

b = PeriBoard(devs[0])
print "** MUC board found"
print "*** Device manufactuerer: %s" % b.getVendorName()
print "*** Device name: %s" %b.getDeviceName()

#turn off all LED
b.setLed(0, 0)
b.setLed(1, 0)
b.setLed(2, 0)

x = pygame.init()
pygame.mixer.init()
pygame.mixer.music.load('data/theme.mp3')
pygame.mixer.music.play(-1)


white =(174,216,206)
black =(0,0,0)
red = (255,0,0)
boo = (153,76,0)
BLACK =(0,0,0)
RED =(255,0,0)


img = pygame.image.load('data/tree.png')
img2 = pygame.image.load('data/dirt.png')
global gameDisplay
gameDisplay = pygame.display.set_mode((800,600))
pygame.display.set_caption('Slither')
block_list = pygame.sprite.Group()
all_sprites_list = pygame.sprite.Group()
dirt_sprites_list = pygame.sprite.Group()
item_list = pygame.sprite.Group()
item_sprites_list = pygame.sprite.Group()
class Dirt(pygame.sprite.Sprite):
    def __init__(self):
         super(Dirt, self).__init__()
         self.image = pygame.image.load("data/dirt.png")
         self.rect = self.image.get_rect()
         self.counter = 200
         self.count = 0
         self.velo = 10
    def update(self):
            
        if self.count>= self.counter:
           self.count = 0
           self.rect.y-=self.counter
        self.count+=self.velo
        self.rect.y+=self.velo

class Dirt2(pygame.sprite.Sprite):
    def __init__(self):
         super(Dirt2, self).__init__()
         self.image = pygame.image.load("data/dirt2.png")
         self.rect = self.image.get_rect()
         self.counter = 200
         self.count = 0
         self.velo = 10
    def update(self):
            
        if self.count>= self.counter:
           self.count = 0
           self.rect.y-=self.counter
        self.count+=self.velo
        self.rect.y+=self.velo
         
class Item(pygame.sprite.Sprite):
    """
    This class represents the ball
    It derives from the "Sprite" class in Pygame
    """
    def __init__(self, color, width, height):
        """ Constructor. Pass in the color of the block,
        and its x and y position. """
        # Call the parent class (Sprite) constructor
        super(Item, self).__init__()
 
        # Create an image of the block, and fill it with a color.
        # This could also be an image loaded from the disk.
        self.image = pygame.image.load("data/Item.png")
        self.run= False
        self.keep = False
        
        # Fetch the rectangle object that has the dimensions of the image
        # image.
        # Update the position of this object by setting the values
        # of rect.x and rect.y
        self.rect = self.image.get_rect()
 
    def update(self):
        """ Called each frame. """
         # Move block down one pixel

        if self.keep == True :
           self.run = True 
           self.rect.y =-50
        
                     
        # If item is out of screen

        if self.rect.y > 600 :
            self.run = True
            self.rect.y =-50
        else :
            if self.run == False :
               self.rect.y += 8
        
           
class Block(pygame.sprite.Sprite):
    """
    This class represents the ball
    It derives from the "Sprite" class in Pygame
    """
    def __init__(self, color, width, height):
        """ Constructor. Pass in the color of the block,
        and its x and y position. """
        # Call the parent class (Sprite) constructor
        super(Block, self).__init__()
 
        # Create an image of the block, and fill it with a color.
        # This could also be an image loaded from the disk.
        self.image = pygame.image.load("data/spike12.png")
        self.velo = 10
 
        # Fetch the rectangle object that has the dimensions of the image
        # image.
        # Update the position of this object by setting the values
        # of rect.x and rect.y
        self.rect = self.image.get_rect()
 
    def reset_pos(self):
        """ Reset position to the top of the screen, at a random x location.
        Called by update() or the main program loop if there is a collision.
        """
        self.rect.y = random.randrange(-300, -20)
        kuy = random.randrange(0,2)
        if kuy==0 :
         self.rect.x = 200
         self.image = pygame.image.load("data/spike12.png")
        else :
         self.rect.x = 570
         self.image = pygame.image.load("data/spike22.png")
    def update(self):
        """ Called each frame. """
         # Move block down one pixel
        self.rect.y += self.velo
 
        # If block is too far down, reset to top of screen.
        if self.rect.y > 600:
            self.reset_pos()
class Ball(pygame.sprite.Sprite):
    """
    This class represents the ball
    It derives from the "Sprite" class in Pygame
    """
    def __init__(self, color, width, height):
        """ Constructor. Pass in the color of the block,
        and its x and y position. """
        # Call the parent class (Sprite) constructor
        super(Ball, self).__init__()
 
        # Create an image of the block, and fill it with a color.
        # This could also be an image loaded from the disk.
        self.image = pygame.image.load("data/ball.png")
        self.kuy = False
 
        # Fetch the rectangle object that has the dimensions of the image
        # image.
        # Update the position of this object by setting the values
        # of rect.x and rect.y
        self.rect = self.image.get_rect()
 
    def update(self):
        """ Called each frame. """
         # Move block down one pixel
         
        # If block is too far down, reset to top of screen.
        if self.rect.y > 600 :
            self.kuy = True
            self.rect.y =-50
        else :
            if self.kuy == False :
               self.rect.y += 15
class Player(pygame.sprite.Sprite):
    """ The player class derives from Block, but overrides the 'update'
    functionality with new a movement function that will move the block
    with the mouse. """
    def __init__(self, color, width, height):
        """ Constructor. Pass in the color of the block,
        and its x and y position. """
        # Call the parent class (Sprite) constructor
        super(Player, self).__init__()
        self.velo = 0
        self.fly = False
        self.keepb = False
        self.walk = 0
        self.charge = False
        # Create an image of the block, and fill it with a color.
        # This could also be an image loaded from the disk.
        self.image = pygame.image.load("data/charr.png")
        # Fetch the rectangle object that has the dimensions of the image
        # image.
        # Update the position of this object by setting the values
        # of rect.x and rect.y
        self.rect = self.image.get_rect()  
    def update(self):
        player.rect.x += player.velo 

      
        if self.rect.x >=570 and self.fly == True:
              self.rect.x =570
              self.velo =0
              self.walk =0
              self.fly = False
     
        if self.rect.x <=200 and self.fly == True:
           self.rect.x =200
           self.walk =1
           self.velo =0
           self.fly = False
 
tree_sprites = pygame.sprite.RenderClear()
font = pygame.font.SysFont(None,35)
for i in range(2):
    # This represents a block
    block = Block(BLACK,20, 15)
 
    # Set a random location for the block
    block.rect.x = 200
    block.rect.y = 0
 
    # Add the block to the list of objects
    block_list.add(block)
    all_sprites_list.add(block)
player = Player(RED, 20, 15)

dirt1  = Dirt()
dirt1.rect.x =-5
dirt1.rect.y =0

dirt2  = Dirt()
dirt2.rect.x =-5
dirt2.rect.y =-200

dirt3  = Dirt()
dirt3.rect.x =-5
dirt3.rect.y =200


dirt4  = Dirt()
dirt4.rect.x =-5
dirt4.rect.y =400


dirt21  = Dirt2()
dirt21.rect.x =605
dirt21.rect.y =0

dirt22  = Dirt2()
dirt22.rect.x =605
dirt22.rect.y =-200

dirt23  = Dirt2()
dirt23.rect.x =605
dirt23.rect.y =200

dirt24  = Dirt2()
dirt24.rect.x =615
dirt24.rect.y =400

dirt24  = Dirt2()
dirt24.rect.x =605
dirt24.rect.y =400
dirt_sprites_list.add(dirt21)
dirt_sprites_list.add(dirt22)
dirt_sprites_list.add(dirt23)
dirt_sprites_list.add(dirt24)

dirt_sprites_list.add(dirt1)
dirt_sprites_list.add(dirt2)
dirt_sprites_list.add(dirt3)
dirt_sprites_list.add(dirt4)

player.rect.x = 570
player.rect.y = 500
all_sprites_list.add(player)

item = Item(RED, 20, 15)
item.rect.x =380
item.rect.y =-50
item_list.add(item)
item_sprites_list.add(item)
item.run = True

def mess(msg,color):
    screen_text = font.render(msg,True,color)
    gameDisplay.blit(screen_text,[380,80])
def mess2(msg,color):
    screen_text2 = font.render(msg,True,color)
    gameDisplay.blit(screen_text2,[280,80])
clock = pygame.time.Clock()
def gameloop():
    rand = random.randrange(0,1)
    fly = False
    gameExit = False
    lead_x = 600
    lead_y = 500
    velo =0
    gameo = False
    time =0
    count =2
    maball = False
    clock = pygame.time.Clock()
    score = 0
    iii= False
    Power = 0
    itemcout = 0
    bbreak = False
    charge = 0
    chargeb = False
    ccount = 0
    
    while not gameExit:
	if b.getSwitch() and player.walk == 0 and player.fly == False and gameo == False:
                   player.velo =-20
                   player.fly = True
                   
	if b.getSwitch() and player.walk == 1 and player.fly == False and gameo== False:
                   player.velo =20
                   player.fly = True

        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                gameExit = True
                   
        gameDisplay.fill(white)
        
        if gameo!=True:
		mess(str(score),red)
           	if player.charge == True :
			score += 2
			if power == 0:
				player.charge = False
				for i in block_list:
				    i.velo = 10

                                for i in dirt_sprites_list :
                                    i.velo = 10
                                chargeb =True
			power -= 1
			charge -= 2
                score+=1
		charge += 2
		if(charge == 600):
			b.setLedValue(1)
		if(charge == 1200):
			b.setLedValue(3)
		if(charge == 1800):
			b.setLedValue(7)
		#use super power
		if charge >= 1800 and b.getLight() <= 150:
			b.setLedValue(0)
			charge = 0
                        for i in block_list:
                            i.velo = 30
                        
                        
                        player.charge = True
			power = 250
        else :
           mess2("Game Over "+"Score "+str(score),red)
        blocks_hit_list = pygame.sprite.spritecollide(player, block_list, False)
        for block in blocks_hit_list:
              if player.keepb == True and player.charge == False :
                 bbreak = True
                 
                 player.image = pygame.image.load("data/charr.png")
              if player.keepb == False and player.charge ==False and chargeb==False:
                 gameo = True

        item_hit_list = pygame.sprite.spritecollide(player, item_list, False)
        for items in item_hit_list:
             
             items.run == True
             items.keep = True
             player.image = pygame.image.load("data/barr.png")
             player.keepb = True
        
        if bbreak == True :
           itemcout+=1
           if itemcout == 20:
               itemcout = 0
               player.keepb = False
               bbreak = False
        if chargeb == True :
              ccount+=1
              if ccount == 30 :
               ccount = 0
               chargeb = False
       
        gameDisplay.blit(img,(100,100))
        
        if score ==200:
            block = Block(BLACK, 20, 15)
            block.rect.x = 200
            block.rect.y = 0
            block_list.add(block)
            all_sprites_list.add(block)
        
        if score %500==0:
            if maball == False:
               ball = Ball(RED, 20, 15)
               ball.rect.x =380
               ball.rect.y =-50
               
               block_list.add(ball)
               all_sprites_list.add(ball)
               maball = True
            else :
                ball.kuy = False
                ball.rect.y =-50
        if score %650 ==0:
            item.keep =False
            item.run = False
        if score %600==0:
            block = Block(RED, 20, 15)
            ran = random.randrange(0,2)
            block.rect.y =0
            block_list.add(block)
            all_sprites_list.add(block)

            if ran ==0 :
               block.rect.x = 200
               block.image = pygame.image.load("data/spike12.png")
            else :
               block.rect.x = 570
               block.image = pygame.image.load("data/spike22.png")
        if player.charge == True :
              for i in block_list:
                 i.velo = 30
              for i in dirt_sprites_list:
                 i.velo = 20
            
        if gameo ==False:
           dirt_sprites_list.update()
           all_sprites_list.update()
           item_sprites_list.update()
           
        all_sprites_list.draw(gameDisplay)
        dirt_sprites_list.draw(gameDisplay)
        item_sprites_list.draw(gameDisplay)
       
        
        clock.tick(30)
        
        pygame.display.update()
        
    pygame.quit()
    quit()
gameloop() 
